diff -ur slackware64-current/source/e/emacs/emacs.SlackBuild slackware64-current.2/source/e/emacs/emacs.SlackBuild
--- slackware64-current/source/e/emacs/emacs.SlackBuild	2021-08-12 15:41:16.000000000 +0200
+++ slackware64-current.2/source/e/emacs/emacs.SlackBuild	2021-09-18 13:41:20.862251020 +0200
@@ -88,6 +88,9 @@
 tar xvf $CWD/$PKGNAM-$TARBALLVER.tar.xz || exit 1
 cd $PKGNAM-$SRCDIRVER || exit 1
 
+# Fix incorrect SIGSTKSZ on or1k:
+zcat $CWD/sigstksz_or1k.diff.gz  | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/installer/build_installer.sh slackware64-current.3/source/installer/build_installer.sh
--- slackware64-current.2/source/installer/build_installer.sh	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/installer/build_installer.sh	2021-09-18 13:42:54.216962753 +0200
@@ -148,9 +148,9 @@
     ADD_NETMODS=1         # add network modules
     ADD_PCMCIAMODS=1      # add pcmcia modules
     ADD_MANPAGES=1        # Add preprocessed manpages
-    DISTRODIR=${DISTRODIR:-"slackware"} # below this you find a,ap,d,..,y
+    #DISTRODIR=${DISTRODIR:-"slackware"} # below this you find a,ap,d,..,y
     COMPRESS_MODS=1       # compress kernel modules
-    LIBDIRSUFFIX=""       # the default
+    #LIBDIRSUFFIX=""       # the default
     RECOMPILE=0           # re-use binaries from existing initrd and packages
     SPLIT_INITRD=0        # Do not create separate initrd for each kernel
     USBBOOT=0             # do not build the USB boot image
diff -ur slackware64-current.2/source/installer/installer.SlackBuild slackware64-current.3/source/installer/installer.SlackBuild
--- slackware64-current.2/source/installer/installer.SlackBuild	2022-09-06 20:27:30.645132064 +0200
+++ slackware64-current.3/source/installer/installer.SlackBuild	2023-05-01 20:57:27.969137234 +0200
@@ -49,6 +49,10 @@
   export ARCH
 fi
 
+if [ -z "$OUTPUT" ]; then
+  OUTPUT=$TMP/installer
+fi
+
 NUMJOBS=${NUMJOBS:-" -j7 "}
 
 mkdir -p $OUTPUT
diff -ur slackware64-current.2/source/kde/kde/cmake/akonadi slackware64-current.3/source/kde/kde/cmake/akonadi
--- slackware64-current.2/source/kde/kde/cmake/akonadi	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/akonadi	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,28 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "ppc" -o "$ARCH" = "sh4" -o "$ARCH" = "or1k" -o "$ARCH" = "sparc" ]
+then
+  CMAKE_EXTRA="-DCMAKE_EXE_LINKER_FLAGS=-latomic"
+fi
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DLIBEXEC_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    $CMAKE_EXTRA \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/digikam slackware64-current.3/source/kde/kde/cmake/digikam
--- slackware64-current.2/source/kde/kde/cmake/digikam	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/digikam	2021-09-18 13:42:54.216962753 +0200
@@ -1,3 +1,8 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "ppc" ]
+then
+  CMAKE_EXTRA="-DCMAKE_SHARED_LINKER_FLAGS=-latomic"
+fi
+
 mkdir cmake-build
 cd cmake-build
   cmake \
@@ -17,6 +22,7 @@
     -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
     -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
     -DBUILD_TESTING=OFF \
+    $CMAKE_EXTRA \
     -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
     -DPYTHON_EXECUTABLE=/usr/bin/python3 \
     -DENABLE_KFILEMETADATASUPPORT=ON \
diff -ur slackware64-current.2/source/kde/kde/cmake/kdenetwork-filesharing slackware64-current.3/source/kde/kde/cmake/kdenetwork-filesharing
--- slackware64-current.2/source/kde/kde/cmake/kdenetwork-filesharing	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/kdenetwork-filesharing	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,29 @@
+if [ "$ARCH" = "riscv64" ]
+then
+  CMAKE_EXTRA="-DCMAKE_MODULE_LINKER_FLAGS=-latomic"
+fi
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    -DPYTHON_EXECUTABLE=/usr/bin/python3 \
+    $CMAKE_EXTRA \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/kmouth slackware64-current.3/source/kde/kde/cmake/kmouth
--- slackware64-current.2/source/kde/kde/cmake/kmouth	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/kmouth	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,23 @@
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DKF_IGNORE_PLATFORM_CHECK=TRUE \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/krita slackware64-current.3/source/kde/kde/cmake/krita
--- slackware64-current.2/source/kde/kde/cmake/krita	2021-09-30 19:56:09.556980609 +0200
+++ slackware64-current.3/source/kde/kde/cmake/krita	2022-07-26 12:11:11.111111111 +0200
@@ -1,3 +1,12 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "riscv64" -o "$ARCH" = "sh4" -o "$ARCH" = "or1k" -o "$ARCH" = "sparc" ]
+then
+  CMAKE_EXTRA="-DCMAKE_SHARED_LINKER_FLAGS=-latomic"
+fi
+if [ "$ARCH" = "or1k" ]
+then
+  SLKCFLAGS="-O2 -mcmodel=large"
+fi
+
 mkdir cmake-build
 cd cmake-build
   cmake \
@@ -17,6 +22,7 @@
     -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
     -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
     -DBUILD_TESTING=OFF \
+    $CMAKE_EXTRA \
     -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
     -DPYTHON_EXECUTABLE=/usr/bin/python3 \
     -DBUILD_KRITA_QT_DESIGNER_PLUGINS=ON \
diff -ur slackware64-current.2/source/kde/kde/cmake/ktimer slackware64-current.3/source/kde/kde/cmake/ktimer
--- slackware64-current.2/source/kde/kde/cmake/ktimer	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/ktimer	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,23 @@
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DKF_IGNORE_PLATFORM_CHECK=TRUE \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/kwin slackware64-current.3/source/kde/kde/cmake/kwin
--- slackware64-current.2/source/kde/kde/cmake/kwin	2000-01-01 01:01:01.000000000 +0200
+++ slackware64-current.3/source/kde/kde/cmake/kwin		2024-03-19 11:09:56.174717894 +0100
@@ -0,0 +1,29 @@
+if [ "$ARCH" = "or1k" ]
+then
+  SLKCFLAGS="-O2 -mcmodel=large"
+fi
+
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    -DPYTHON_EXECUTABLE=/usr/bin/python3 \
+    ..
+
diff -ur slackware64-current.2/source/kde/kde/cmake/syntax-highlighting slackware64-current.3/source/kde/kde/cmake/syntax-highlighting
--- slackware64-current.2/source/kde/kde/cmake/syntax-highlighting	2020-10-15 01:30:57.815498320 +0200
+++ slackware64-current.3/source/kde/kde/cmake/syntax-highlighting	2021-09-18 13:42:54.216962753 +0200
@@ -0,0 +1,28 @@
+if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" -o "$ARCH" = "arm" -o "$ARCH" = "ppc" -o "$ARCH" = "or1k" -o "$ARCH" = "sh4" ]
+then
+  CMAKE_EXTRA="-DCMAKE_SHARED_LINKER_FLAGS=-latomic"
+fi
+mkdir cmake-build
+cd cmake-build
+  cmake \
+    $KDE_OPT_ARGS \
+    -DKDE_PLATFORM_FEATURE_DISABLE_DEPRECATED=TRUE \
+    -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
+    -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    -DCMAKE_BUILD_TYPE=Release \
+    -DCMAKE_INSTALL_PREFIX=/usr \
+    -DMAN_INSTALL_DIR=/usr/man \
+    -DSYSCONF_INSTALL_DIR=/etc/kde \
+    -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+    -DLIB_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DLIBEXEC_INSTALL_DIR=lib$LIBDIRSUFFIX \
+    -DQT_PLUGIN_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/plugins \
+    -DQML_INSTALL_DIR=lib$LIBDIRSUFFIX/qt5/qml \
+    -DKDE_INSTALL_USE_QT_SYS_PATHS=ON \
+    -DBUILD_TESTING=OFF \
+    -DQca-qt5_DIR=/usr/lib${LIBDIRSUFFIX}/cmake/Qca \
+    $CMAKE_EXTRA \
+    ..
+
diff -ur slackware64-current.2/source/l/aalib/aalib.SlackBuild slackware64-current.3/source/l/aalib/aalib.SlackBuild
--- slackware64-current.2/source/l/aalib/aalib.SlackBuild	2021-02-13 06:31:56.092945400 +0100
+++ slackware64-current.3/source/l/aalib/aalib.SlackBuild	2021-09-18 13:42:54.276965781 +0200
@@ -71,7 +71,8 @@
 tar xvf $CWD/${PKGNAM}-$VERSION.tar.gz || exit 1
 cd ${PKGNAM}-${SRCVER} || exit 1
 #cp /usr/share/libtool/config.{guess,sub} .             # libtool-1.x
-cp /usr/share/libtool/config/config.{guess,sub} .       # libtool-2.x
+#cp /usr/share/libtool/config/config.{guess,sub} .       # libtool-2.x
+\cp /usr/share/libtool/build-aux/config.* . 
 sed -i -e "s# -lslang# -lslang1#" configure
 
 zcat $CWD/aalib-aclocal.patch.gz | patch -p1 --verbose || exit 1
diff -ur slackware64-current.2/source/l/apr/apr.SlackBuild slackware64-current.3/source/l/apr/apr.SlackBuild
--- slackware64-current.2/source/l/apr/apr.SlackBuild	2023-02-01 22:28:25.912750044 +0100
+++ slackware64-current.3/source/l/apr/apr.SlackBuild	2023-07-27 14:25:42.455046559 +0200
@@ -78,7 +82,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Fix incorrect mutex definitions for or1k:
+zcat $CWD/proc_mutex.diff.gz | patch -p1 --verbose || exit 1
+
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/l/boost/boost.SlackBuild slackware64-current.3/source/l/boost/boost.SlackBuild
--- slackware64-current.2/source/l/boost/boost.SlackBuild	2021-02-13 06:31:56.229945393 +0100
+++ slackware64-current.3/source/l/boost/boost.SlackBuild	2021-09-18 13:42:54.296966791 +0200
@@ -85,6 +85,13 @@
 tar xvf $CWD/boost_$VERSION.tar.?z || exit 1
 cd boost_$VERSION || exit 1
 
+# From 1.77 BOOST_MATH_NO_ATOMIC_INT was removed from bernoulli code.
+# Reintegrate it:
+zcat $CWD/reintegrate_BOOST_MATH_NO_ATOMIC_INT.diff.gz | patch -p1 --verbose || exit 1
+# Change -mcpu=v7 to -mcpu=leon3 for sparc to support atomic operation (otherwise
+# "Boost.Atomic unsupported target platform: native atomic operations not implemented for bytes):
+zcat $CWD/sparc_cpu_leon3.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/chmlib/chmlib.SlackBuild slackware64-current.3/source/l/chmlib/chmlib.SlackBuild
--- slackware64-current.2/source/l/chmlib/chmlib.SlackBuild	2021-02-13 06:31:56.568945374 +0100
+++ slackware64-current.3/source/l/chmlib/chmlib.SlackBuild	2021-09-18 13:42:54.346969315 +0200
@@ -70,6 +70,13 @@
 rm -rf chmlib-$VERSION
 tar xvf $CWD/chmlib-$VERSION.tar.?z* || exit 1
 cd chmlib-$VERSION || exit 1 || exit 1
+
+# These patches are still needed for arm:
+for i in src_chm_lib.c.diff.gz src_extract_chmLib.c.diff.gz
+do
+  zcat $CWD/$i | patch -p1
+done
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/cryfs/cryfs.SlackBuild slackware64-current.3/source/l/cryfs/cryfs.SlackBuild
--- slackware64-current.2/source/l/cryfs/cryfs.SlackBuild	2021-02-13 06:31:56.635945370 +0100
+++ slackware64-current.3/source/l/cryfs/cryfs.SlackBuild	2021-09-18 13:42:54.396971838 +0200
@@ -79,6 +79,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix building for bigendian or1k
+sed -i -e "s/defined(__ARMEB__)/defined(__ARMEB__) || defined(__or1k__)/" vendor/cryptopp/vendor_cryptopp/config.h
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -89,6 +89,12 @@
 # Oddly, cryfs expects a static boost, so we'll need to hit it with the LART:
 export LDFLAGS="$SLKLDFLAGS -lboost_thread -lboost_program_options -lboost_filesystem -lboost_chrono -lcryptopp -lfuse"
 
+case "$ARCH" in
+  arm|mips|mipsel|ppc|or1k|sh4)
+    export LDFLAGS="$LDFLAGS -latomic"
+    ;;
+esac
+
 # gcc11 fixes:
 zcat $CWD/27587ea1acec5f939a31217f1c43953378f18821.patch.gz | patch -p1 --verbose || exit 1
 
diff -ur slackware64-current.2/source/l/cryptopp/cryptopp.SlackBuild slackware64-current.3/source/l/cryptopp/cryptopp.SlackBuild
--- slackware64-current.2/source/l/cryptopp/cryptopp.SlackBuild	2021-02-13 06:31:56.635945370 +0100
+++ slackware64-current.3/source/l/cryptopp/cryptopp.SlackBuild	2021-09-18 13:42:54.396971838 +0200
@@ -95,6 +95,11 @@
 # Cater to 64-bit Slackware:
 sed -i -e "s,(PREFIX)/lib,(PREFIX)/lib${LIBDIRSUFFIX},g" GNUmakefile
 
+# Disable NEON on armv5:
+sed -i -e "s/if defined(__arm__) || defined(__ARM_NEON)/if defined(__ARM_NEON)/" config.h
+# Fix building for bigendian or1k
+sed -i -e "s/defined(__ARMEB__)/defined(__ARMEB__) || defined(__or1k__)/" config.h
+
 # Compile and install:
 make all dynamic libcryptopp.pc $NUMJOBS \
   CXXFLAGS="${SLKCFLAGS} -DNDEBUG" LDFLAGS="${LDFLAGS}"
diff -ur slackware64-current.2/source/l/ffmpeg/ffmpeg.SlackBuild slackware64-current.3/source/l/ffmpeg/ffmpeg.SlackBuild
--- slackware64-current.2/source/l/ffmpeg/ffmpeg.SlackBuild	2024-02-09 00:19:22.862311554 +0100
+++ slackware64-current.3/source/l/ffmpeg/ffmpeg.SlackBuild	2024-02-10 12:57:11.806102782 +0100
@@ -197,6 +197,9 @@
 tar xf $CWD/$PKGNAM-$VERSION.tar.xz || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix missing #if...#else...#endif for older (<2.52) librsvg versions:
+zcat $CWD/old_librsvg.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find -L . \
  \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
@@ -215,6 +215,7 @@
 
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
@@ -263,6 +263,7 @@
   $chromaprint \
   $decklink \
   $fdk \
+  $EXTRACONF \
   $fontconfig \
   $freetype \
   $fribidi \
diff -ur slackware64-current.2/source/l/fftw/fftw.SlackBuild slackware64-current.3/source/l/fftw/fftw.SlackBuild
--- slackware64-current.2/source/l/fftw/fftw.SlackBuild	2021-09-17 05:10:46.589065042 +0200
+++ slackware64-current.3/source/l/fftw/fftw.SlackBuild	2021-09-18 13:42:54.496976886 +0200
@@ -51,22 +51,42 @@
 PKG=$TMP/package-$PKGNAM-$VERSION
 OUTPUT=${OUTPUT:-/tmp}
 
+QUAD=""
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
   SIMD="--enable-sse2 --enable-avx"
+  SIMDF="$SIMD"
+  QUAD="yes"
 elif [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=i686 -mtune=i686"
   LIBDIRSUFFIX=""
   SIMD="--enable-sse2 --enable-avx"
+  SIMDF="$SIMD"
+  QUAD="yes"
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX="64"
   SIMD="--enable-sse2 --enable-avx"
-else
-  SLKCFLAGS="-O2"
+  SIMDF="$SIMD"
+  QUAD="yes"
+elif [ "$ARCH" = "armv7hl" ]; then
+  SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX=""
   SIMD=""
+  SIMDF="--enable-neon"
+elif [ "$ARCH" = "aarch64" ]; then
+  SLKCFLAGS="-O2"
+  LIBDIRSUFFIX="64"
+  SIMD=""
+  SIMDF="$SIMD"
+else
+  SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+  LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+  SIMD=${SIMD:-""}
+  SIMDF=${SIMDF:-""}
+  QUAD=${QUAD:-""}
 fi
 
 rm -rf $PKG
@@ -115,7 +135,7 @@
     --enable-threads \
     --enable-openmp \
     --enable-float \
-    $SIMD \
+    $SIMDF \
     --build=$ARCH-slackware-linux || exit 1
 
 make $NUMJOBS || make || exit 1
@@ -142,24 +162,27 @@
 make install-strip DESTDIR=$PKG || exit 1
 make clean
 
-# compile libfftw3q
-./configure \
-    --prefix=/usr \
-    --libdir=/usr/lib${LIBDIRSUFFIX} \
-    --sysconfdir=/etc \
-    --localstatedir=/var \
-    --mandir=/usr/man \
-    --infodir=/usr/info \
-    --docdir=/usr/doc/fftw-$VERSION \
-    --enable-shared \
-    --disable-static \
-    --enable-threads \
-    --enable-openmp \
-    --enable-quad-precision \
-    --build=$ARCH-slackware-linux || exit 1
+if [ "$QUAD" != "" ]
+then
+    # compile libfftw3q
+    ./configure \
+	--prefix=/usr \
+	--libdir=/usr/lib${LIBDIRSUFFIX} \
+	--sysconfdir=/etc \
+	--localstatedir=/var \
+	--mandir=/usr/man \
+	--infodir=/usr/info \
+	--docdir=/usr/doc/fftw-$VERSION \
+	--enable-shared \
+	--disable-static \
+	--enable-threads \
+	--enable-openmp \
+	--enable-quad-precision \
+	--build=$ARCH-slackware-linux || exit 1
 
-make $NUMJOBS || make || exit 1
-make install-strip DESTDIR=$PKG || exit 1
+    make $NUMJOBS || make || exit 1
+    make install-strip DESTDIR=$PKG || exit 1
+fi
 
 # Don't ship .la files:
 rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
diff -ur slackware64-current.2/source/l/fuse/fuse.SlackBuild slackware64-current.3/source/l/fuse/fuse.SlackBuild
--- slackware64-current.2/source/l/fuse/fuse.SlackBuild	2021-02-13 06:31:57.244945337 +0100
+++ slackware64-current.3/source/l/fuse/fuse.SlackBuild	2021-09-18 13:42:54.546979410 +0200
@@ -72,6 +72,10 @@
 rm -rf $PKGNAM-$VERSION
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z* || exit 1
 cd $PKGNAM-$VERSION || exit 1
+
+# Fix AArch64 already defined __u64/__s64/__u32/__s32/__u16:
+zcat $CWD/fuse_kernel-types.patch.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/gc/gc.SlackBuild slackware64-current.3/source/l/gc/gc.SlackBuild
--- slackware64-current.2/source/l/gc/gc.SlackBuild	2021-02-13 06:31:57.244945337 +0100
+++ slackware64-current.3/source/l/gc/gc.SlackBuild	2021-09-18 13:42:54.546979410 +0200
@@ -74,6 +74,11 @@
 tar xvf $CWD/libatomic_ops-$LAO_VERSION.tar.?z || exit 1
 mv libatomic_ops-$LAO_VERSION libatomic_ops
 
+if [ "$ARCH" = "sparc" ]; then
+  # Disable sparcv9 code:
+  zcat $CWD/atomic_ops_sparcv8.diff.gz | patch -p1 --verbose || exit 1
+fi
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/gjs/gjs.SlackBuild slackware64-current.3/source/l/gjs/gjs.SlackBuild
--- slackware64-current.2/source/l/gjs/gjs.SlackBuild	2021-02-13 06:31:57.244945337 +0100
+++ slackware64-current.3/source/l/gjs/gjs.SlackBuild	2021-09-18 13:42:54.546979410 +0200
@@ -83,6 +83,7 @@
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
+export LDFLAGS="$SLKLDFLAGS"
 mkdir meson-build
 cd meson-build
 meson setup \
diff -ur slackware64-current.2/source/l/glibc/glibc.SlackBuild slackware64-current.3/source/l/glibc/glibc.SlackBuild
--- slackware64-current.2/source/l/glibc/glibc.SlackBuild	2021-08-17 21:01:07.631022697 +0200
+++ slackware64-current.3/source/l/glibc/glibc.SlackBuild	2021-09-18 13:42:54.606982438 +0200
@@ -70,30 +70,37 @@
   i386)
     OPTIMIZ="-O3 -march=i386 -mcpu=i686"
     LIBDIRSUFFIX=""
+    LIBDIRSUFFIXROOT=""
     ;;
   i486)
     OPTIMIZ="-O3 -march=i486 -mtune=i686"
     LIBDIRSUFFIX=""
+    LIBDIRSUFFIXROOT=""
     ;;
   i586)
     OPTIMIZ="-O3 -march=i586 -mtune=i686"
     LIBDIRSUFFIX=""
+    LIBDIRSUFFIXROOT=""
     ;;
   i686)
     OPTIMIZ="-O3 -march=i686"
     LIBDIRSUFFIX=""
+    LIBDIRSUFFIXROOT=""
     ;;
   athlon)
     OPTIMIZ="-O3 -march=athlon"
     LIBDIRSUFFIX=""
+    LIBDIRSUFFIXROOT=""
     ;;
   s390)
     OPTIMIZ="-O3"
     LIBDIRSUFFIX=""
+    LIBDIRSUFFIXROOT=""
     ;;
   x86_64)
     OPTIMIZ="-O3 -fPIC"
     LIBDIRSUFFIX="64"
+    LIBDIRSUFFIXROOT="64"
     ;;
   *)
     OPTIMIZ="-O3"
@@ -102,13 +109,8 @@
 esac
 
 case $ARCH in
-  x86_64)
-    TARGET=${TARGET:-x86_64}
-    ;;
-  i586)
-    # This should be i586 for all 32-bit x86 arch:
-    TARGET=${TARGET:-i586}
-    ;;
+    arm*) TARGET=${TARGET:-$ARCH-slackware-linux-gnueabi} ;;
+    *)    TARGET=${TARGET:-$ARCH-slackware-linux} ;;
 esac
 
 # Hand off the $ARCH variable to $SLACKWARE_ARCH to avoid confusing glibc:
@@ -128,18 +137,54 @@
 # This function fixes a doinst.sh file for x86_64.
 # With thanks to Fred Emmott.
 fix_doinst() {
-  if [ "x$LIBDIRSUFFIX" = "x" ]; then
-    return;
-  fi;
-  # Fix "( cd usr/lib ;" occurrences
-  sed -i "s#lib ;#lib${LIBDIRSUFFIX} ;#" install/doinst.sh
+  if [ "x$LIBDIRSUFFIXROOT" != "x" ]; then
+  # Fix "( cd usr/lib ;" occurrences (shoul fix nothing)
+  sed -i "s#usr/lib ;#usr/lib${LIBDIRSUFFIX} ;#" install/doinst.sh
+  # Fix "( cd lib ;" occurrences
+  sed -i "s# lib ;# lib${LIBDIRSUFFIXROOT} ;#" install/doinst.sh
   # Fix "lib/" occurrences
-  sed -i "s#lib/#lib${LIBDIRSUFFIX}/#g" install/doinst.sh
+  sed -i "s#lib/#lib${LIBDIRSUFFIXROOT}/#g" install/doinst.sh
   # Fix "( cd lib" occurrences
-  sed -i "s#( cd lib\$#( cd lib${LIBDIRSUFFIX}#" install/doinst.sh
+  sed -i "s#( cd lib\$#( cd lib${LIBDIRSUFFIXROOT}#" install/doinst.sh
+  fi;
 
   if [ "$SLACKWARE_ARCH" = "x86_64" ]; then
     sed -i 's#ld-linux.so.2#ld-linux-x86-64.so.2#' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "arm" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux.so.3#' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "armv7hl" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux-armhf.so.3#' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "aarch64" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux-aarch64.so.1#' install/doinst.sh
+    if [[ "x$LIBDIRSUFFIX" != "x" ]]
+    then
+      # All binaries are linked by default to /lib/ld-linux-aarch64.so.1, so make sure
+      # the file/link exists
+      echo -e "\n# Make sure /lib/ld-linux-aarch64.so.1 links to the correct file\n\n(cd lib; ln -sf ../lib$LIBDIRSUFFIXROOT/ld-linux-aarch64.so.1 . )\n" >> install/doinst.sh
+    fi
+  elif [ "${SLACKWARE_ARCH::5}" = "ppc64" ]; then
+    sed -i 's#ld-linux.so.2#ld64.so.1#' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "riscv64" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux-riscv64-lp64d.so.1#' install/doinst.sh
+    # All binaries are linked by default to /lib/ld-linux-riscv64-lp64d.so.1, so make sure
+    # the file/link exists
+    echo -e "\n# Make sure /lib/ld-linux-riscv64-lp64d.so.1 links to the correct file\n(cd lib; ln -sf ../lib$LIBDIRSUFFIXROOT/ld-linux-riscv64-lp64d.so.1 . )\n(cd lib64; ln -sf lp64d/ld-linux-riscv64-lp64d.so.1 . )\n" >> install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "s390x" ]; then
+    sed -i 's#ld-linux.so.2#ld64.so.1#' install/doinst.sh
+    # All binaries are linked by default to /lib/ld64.so.1, so make sure
+    # the file/link exists
+    echo -e "\n# Make sure /lib/ld64.so.1 links to the correct file\n\n(cd lib; ln -sf ../lib$LIBDIRSUFFIXROOT/ld64.so.1 . )\n" >> install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "or1k" ]; then
+    sed -i 's#ld-linux.so.2#ld-linux-or1k.so.1#' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "hppa" ]; then
+    sed -i 's#ld-linux.so.2#ld.so.1#' install/doinst.sh
+  elif [ "$SLACKWARE_ARCH" = "alpha" ]; then
+    # Alpha adds .1 on some libraries, change it and make additional link
+    for lib in libresolv.so.2 libnsl.so.1 libm.so.6 libutil.so.1 libcrypt.so.1 libBrokenLocale.so.1 libdl.so.2
+    do
+      sed -i "s#$lib #$lib.1 #" install/doinst.sh
+      echo -e "(cd lib$LIBDIRSUFFIX; ln -s $lib.1 $lib 2>/dev/null)\n" >> install/doinst.sh
+    done
   fi
 }
 
@@ -155,6 +200,14 @@
   for git_patch in $CWD/patches/*.patch.gz ; do
     zcat $git_patch | patch -p1 --verbose || exit 1
   done
+
+  # Set time64 as default on 32-bit architectures (only exception is or1k which 
+  # has __TIMESIZE == 64 (/usr/include/bits/timesize.h).
+  case $SLACKWARE_ARCH in
+    arm|armv7hl|hppa|mips|mipsel|ppc|sh4|i?86)
+    zcat $CWD/time64default.diff.gz | patch -p1 --verbose || exit 1
+    ;;
+  esac
 }
 
 # This is going to be the initial $DESTDIR:
@@ -179,7 +207,7 @@
 fi
 
 # Create an incoming directory structure for glibc to be built into:
-mkdir -p $PKG/lib${LIBDIRSUFFIX}
+mkdir -p $PKG/lib${LIBDIRSUFFIXROOT}
 mkdir -p $PKG/sbin
 mkdir -p $PKG/usr/bin
 mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}
@@ -241,7 +269,7 @@
   --with-tls \
   --with-__thread \
   --without-cvs \
-  $TARGET-slackware-linux
+  $TARGET
 
 make $NUMJOBS || exit 1
 make $NUMJOBS install install_root=$PKG || exit 1
@@ -274,7 +302,7 @@
 # /usr/lib/debug/ and stripping the debugging symbols from all the other
 # libraries.
 mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}/debug
-cp -a $PKG/lib${LIBDIRSUFFIX}/l*.so* $PKG/usr/lib${LIBDIRSUFFIX}/debug
+cp -a $PKG/lib${LIBDIRSUFFIXROOT}/l*.so* $PKG/usr/lib${LIBDIRSUFFIX}/debug
 cp -a $PKG/usr/lib${LIBDIRSUFFIX}/*.a $PKG/usr/lib${LIBDIRSUFFIX}/debug
 # Don't need debug+profile:
 ( cd $PKG/usr/lib${LIBDIRSUFFIX}/debug ; rm -f *_p.* )
@@ -286,8 +314,32 @@
 #mv $PKG/usr/lib${LIBDIRSUFFIX}/debug/*_p.a $PKG/usr/lib${LIBDIRSUFFIX}
 # It might be best to put the unstripped and profiling libraries in glibc-debug and glibc-profile.
 
+if [ "$SLACKWARE_ARCH" = "aarch64" -a "$LIBDIRSUFFIX" = "64" ]
+then
+  # On aarch64 the default linker is on /lib/ld-linux-aarch64.so.1,
+  # and from glibc-2.34 it is no more a link.
+  # Move it to /lib64 so it will be correctly renamed later by this build scripts.
+  mv $PKG/lib/ld-linux-aarch64.so.1 $PKG/lib$LIBDIRSUFFIXROOT
+fi
+
+if [ "$SLACKWARE_ARCH" = "riscv64" ]
+then
+  # On riscv64 the default linker is on /lib/ld-linux-riscv64-lp64d.so.1,
+  # and from glibc-2.34 it is no more a link.
+  # Move it to /lib64/lp64d so it will be correctly renamed later by this build scripts.
+  mv $PKG/lib/ld-linux-riscv64-lp64d.so.1 $PKG/lib$LIBDIRSUFFIXROOT
+fi
+
+if [ "$SLACKWARE_ARCH" = "s390x" ]
+then
+  # On s390x the default linker is on /lib/ld64.so.1,
+  # and from glibc-2.34 it is no more a link.
+  # Move it to /lib64 so it will be correctly renamed later by this build scripts.
+  mv $PKG/lib/ld64.so.1 $PKG/lib$LIBDIRSUFFIXROOT
+fi
+
 # I don't think "strip -g" causes the pthread problems.  It's --strip-unneeded that does.
-strip -g $PKG/lib${LIBDIRSUFFIX}/l*.so*
+strip -g $PKG/lib${LIBDIRSUFFIXROOT}/l*.so*
 strip -g $PKG/usr/lib${LIBDIRSUFFIX}/l*.so*
 strip -g $PKG/usr/lib${LIBDIRSUFFIX}/lib*.a
 
@@ -399,7 +451,7 @@
 chmod 755 etc/profile.d/*
 mkdir -p lib${LIBDIRSUFFIX}
 cp -a $PKG/lib${LIBDIRSUFFIX}/* lib${LIBDIRSUFFIX}
-( cd lib${LIBDIRSUFFIX}
+( cd lib${LIBDIRSUFFIXROOT}
   mkdir incoming
   mv *so* incoming
   mv incoming/libmemusage.so .
@@ -420,6 +472,7 @@
   # installed in the same directory anyway. So give it the previous name
   # format:
   mv ld-linux*-${VERSION}.so ld-${VERSION}.so
+  mv ld64*-${VERSION}.so ld-${VERSION}.so
 )
 mkdir -p usr
 cp -a $PKG/usr/bin usr
@@ -472,7 +525,7 @@
 sed -i "s/@@VERSION@@/$VERSION/g" install/doinst.sh
 # Call the function to fix doinst.sh where $LIBDIRSUFFIX is needed:
 fix_doinst
-( cd lib${LIBDIRSUFFIX}
+( cd lib${LIBDIRSUFFIXROOT}
   mkdir incoming
   mv *so* incoming
   mv incoming/libmemusage.so .
@@ -493,6 +546,7 @@
   # installed in the same directory anyway. So give it the previous name
   # format:
   mv ld-linux*-${VERSION}.so ld-${VERSION}.so
+  mv ld64*-${VERSION}.so ld-${VERSION}.so
 )
 # Build the package:
 /sbin/makepkg -l y -c n $TMP/glibc-$VERSION-$SLACKWARE_ARCH-$BUILD.txz
diff -ur slackware64-current.2/source/l/gnu-efi/gnu-efi.SlackBuild slackware64-current.3/source/l/gnu-efi/gnu-efi.SlackBuild
--- slackware64-current.2/source/l/gnu-efi/gnu-efi.SlackBuild	2021-08-17 21:01:07.631022697 +0200
+++ slackware64-current.3/source/l/gnu-efi/gnu-efi.SlackBuild	2021-09-18 13:42:54.606982438 +0200
@@ -71,6 +71,10 @@
 chown -R root:root .
 chmod -R u+w,go+r-w,a-s .
 
+# gnu-efi search "initplat.c" in lib/$ARCH, but ARCH is wrongly set
+SLACKWARE_ARCH=$ARCH
+unset ARCH
+
 sed -i "s,/usr/local,/usr,g" Make.defaults
 
 make CPPFLAGS="$SLKCFLAGS" || exit 1
@@ -89,6 +93,9 @@
 )
 strip -g $PKG/usr/lib${LIBDIRSUFFIX}/libefi.a
 
+# Restore ARCH after library build
+ARCH=$SLACKWARE_ARCH
+
 mkdir -p $PKG/usr/doc/$PKGNAM-$VERSION
 cp -a ChangeLog README* \
  $PKG/usr/doc/$PKGNAM-$VERSION
diff -ur slackware64-current.2/source/l/gobject-introspection/gobject-introspection.SlackBuild slackware64-current.3/source/l/gobject-introspection/gobject-introspection.SlackBuild
--- slackware64-current.2/source/l/gobject-introspection/gobject-introspection.SlackBuild	2021-02-13 06:31:58.058945292 +0100
+++ slackware64-current.3/source/l/gobject-introspection/gobject-introspection.SlackBuild	2021-09-18 13:42:54.756990010 +0200
@@ -106,7 +106,7 @@
   --buildtype=release \
   -Dgtk_doc=true \
   .. || exit 1
-  "${NINJA:=ninja}" $NUMJOBS || exit 1
+  "${NINJA:=ninja}" $NUMJOBS || $NINJA || exit 1
   DESTDIR=$PKG $NINJA install || exit 1
 cd ..
 
